.include "m8def.inc"
 
.def iwr0      = r1
.def iwr1      = r2
 
.def key_old   = r3
.def key_state = r4
.def key_press = r5
 
.def temp1     = r17
 
.equ key_pin   = PIND
.equ key_port  = PORTD
.equ key_ddr   = DDRD
 
.def leds      = r16
.equ led_port  = PORTB
.equ led_ddr   = DDRB
 
.org 0x0000
    rjmp    init
 
.org OVF0addr
    rjmp    timer_overflow0
 
timer_overflow0:               ; Timer Overflow Interrupt
 
    push    r0                 ; temporre Register sichern
    in      r0, SREG
    push    r0
    push    iwr0
    push    iwr1
 
get8key:                       ;/old      state     iwr1      iwr0
    mov     iwr0, key_old      ;00110011  10101010            00110011
    in      key_old, key_pin   ;11110000
    eor     iwr0, key_old      ;                              11000011
    com     key_old            ;00001111
    mov     iwr1, key_state    ;                    10101010
    or      key_state, iwr0    ;          11101011
    and     iwr0, key_old      ;                              00000011
    eor     key_state, iwr0    ;          11101000
    and     iwr1, iwr0         ;                    00000010
    or      key_press, iwr1    ; gedrckte Taste merken
;
;
    pop     iwr1               ; Register wiederherstellen
    pop     iwr0
    pop     r0
    out     SREG, r0
    pop     r0
    reti
 
 
init:
    ldi      temp1, LOW(RAMEND)     ; Stackpointer initialisieren
    out      SPL, temp1
    ldi      temp1, HIGH(RAMEND)
    out      SPH, temp1
 
    ldi      temp1, 0xFF
    out      led_ddr, temp1
 
    ldi      temp1, 0xFF            ; Tasten sind auf Eingang
    out      key_port, temp1        ; Pullup Widerstnde ein
 
    ldi      temp1, 1<<CS02 | 1<<CS00   ; Timer mit Vorteiler 1024
    out      TCCR0, temp1
    ldi      temp1, 1<<TOIE0            ; Timer Overflow Interrupt einrichten
    out      TIMSK, temp1
 
    clr      key_old                ; die Register fr die Tastenauswertung im
    clr      key_state              ; Timer Interrupt initialisieren
    clr      key_press
 
    sei                             ; und los gehts: Timer frei
 
    ldi      leds, 0xFF
    out      led_port, leds
main:
    cli                             ; 
    mov      temp1, key_press       ; Einen ev. Tastendruck merken und ...
    clr      key_press              ; Tastendruck zurcksetzen
    sei
 
    cpi      temp1, 0               ; Tastendruck auswerten. Wenn eine von 8 Tasten
    breq     main                   ; gedrckt worden wre, wre ein entsprechendes
                                    ; Bit in key_press gesetzt gewesen
 
    eor      leds, temp1            ; Die zur Taste gehrende Led umschalten
    out      led_port, leds
    rjmp     main